#!/bin/bash 

source /ConfigCheck/Config/Cycle.txt

PWD=`pwd`
ROOT=$PWD

echo "0" > /ConfigCheck/Config/Count

#Enable Ubuntu autologin use root

if [ ! -f "/etc/os-release" ] ; then
echo "CAN NOT IDENTIFY THE OS."
exit 0
else
os_type=`cat /etc/os-release |grep "PRETTY_NAME"|awk -F "=" '{print $2}' | sed -e 's/"//g'`
os_id=`cat /etc/os-release | grep "^ID=" | awk -F "=" '{print $2}' | sed -e 's/"//g'`
os_version=`cat /etc/os-release |grep "VERSION_ID"|awk -F "=" '{print $2}' | sed -e 's/"//g' | sed -e 's/\.[1-9]/.x/'`
fi
echo "OS_TYPE: $os_type"
echo "OS_ID: $os_id"
echo "OS_VERSION: $os_version"

if [ "$os_id" == "ubuntu" ]; then
       cp -f /ConfigCheck/Config/Ubuntu_setting/50-unity-greeter.conf /usr/share/lightdm/lightdm.conf.d
       cp -f /ConfigCheck/Config/Ubuntu_setting/gdm-autologin /etc/pam.d
       cp -f /ConfigCheck/Config/Ubuntu_setting/gdm-password /etc/pam.d
case "$os_version" in
"18.04")
        cp -f /ConfigCheck/Config/Ubuntu_setting/custom.conf /etc/gdm3
        cp -f /ConfigCheck/Config/Ubuntu_setting/.profile /root

;;
"20.04")
	cp -f /ConfigCheck/Config/Ubuntu_setting/custom.conf /etc/gdm3

;;

esac

fi

#Use gnome-session-properties to start configcheck with gnome-terminal
mkdir ~/.config/autostart 
cp /ConfigCheck/Config/gnome-terminal.desktop ~/.config/autostart 

#Enable autologin use root#
mv /etc/gdm/custom.conf /etc/gdm/custom_backup.conf
cp -f /ConfigCheck/Config/custom.conf /etc/gdm

rm -f /ConfigCheck/log*
rm -f /ConfigCheck/ConfigureFile
rm -f /ConfigCheck/GoldenConfigureFile
rm -f /ConfigCheck/faillog/*log*
rm -f /ConfigCheck/faillog/source_log/*ConfigureFile

Check_BMCVersion() {

    ipmitool mc info 2>/dev/null >> /ConfigCheck/ConfigureFile

}

Check_DeviceCheck() {

    lspci -vv | tr -d + | tr -d - | sed "/Address/d" | sed "/Interrupt/d" >> /ConfigCheck/ConfigureFile 

}

Check_HddCheck() {

    a=`fdisk -l | grep "Disk /dev/sd[a-z]" | wc -l`
    b=`fdisk -l | grep "Disk /dev/hd[a-z]" | wc -l`
    c=`fdisk -l | grep "Disk /dev/nvme[0-9][a-z]" | wc -l`
    sum=`expr $a + $b + $c`
	
    echo -e "Total HDD q'ty: $sum" >> /ConfigCheck/ConfigureFile

}

Check_HddCheck2() {

    hdd=($(smartctl --scan | grep "/dev/sd" | awk -F'-d' '{print$1}'))

    for((i=0; i<${#hdd[@]};i++))
    do
	    echo -e "==============================HDD$i==============================" >> /ConfigCheck/ConfigureFile
        smartctl -i ${hdd[$i]} | grep -E -i "Device Model:|Serial Number:|Firmware Version:|SATA Version is:" >> /ConfigCheck/ConfigureFile
    done

}

Check_MemoryTotalSize() {

    cat /proc/meminfo | grep "MemTotal" | awk '{print $2 }' > /ConfigCheck/MemoryConfig

}

Check_LanLinkCheck() {

	server_ip0=`cat /ConfigCheck/Config/Config_Server.txt`
    awk '{print $1" "$2}' < /ConfigCheck/Config/IP_Address.txt | while read ip interface;
    do
        if ping -c4 $server_ip0 -I $ip -w 30 ; then
	        result=$?
        else
	        result=$?
        fi

        if [ $result == 0 ]; then
	        echo "$ip is link"
        else
	        echo "$ip is not link"
	        echo "$(cat $ROOT/count): Lan Link Check fail " >> /ConfigCheck/log2
	        exit 1
        fi
    done
}

Check_IperfCheck() {

    rm -f /ConfigCheck/golden_iperf

    awk '{print $1" "$2}' < /ConfigCheck/Config/IP_Address.txt | while read ip interface;
    do
	    iperf -c $server_ip0 -B $ip > IperfResult.txt 	
	    tail -n 1 IperfResult.txt | awk -F"Bytes" '{print $2}' | awk -F" " '{print $1}' > golden_iperf
    done
	
}

#Check_BMCVersion
#Check_DeviceCheck
#/ConfigCheck/Config/DeviceCheck.sh
Check_HddCheck
#Check_HddCheck2
mv /ConfigCheck/ConfigureFile /ConfigCheck/GoldenConfigureFile
#Check_MemoryTotalSize
#mv /ConfigCheck/MemoryConfig /ConfigCheck/GoldenMemoryConfig
cat /ConfigCheck/GoldenConfigureFile
#cat /ConfigCheck/GoldenMemoryConfig
if [ "$AC" -eq 1 ]; then
    Check_LanLinkCheck
    Check_IperfCheck
fi
