#!/bin/bash

source /ConfigCheck/Config/Cycle.txt

PWD=`pwd`
ROOT=$PWD

rm -f /ConfigCheck/ConfigureFile
rm -f /ConfigCheck/result_check.txt

FILE=/ConfigCheck/Config/Count

#if [ ! -f  $FILE ] ; then
#    echo 0 > $FILE
#fi

count=`cat $FILE`
#echo $count
echo $(($count+1)) > $FILE

count=`cat $FILE`

Check_BMCVersion() {

    ipmitool mc info 2>/dev/null >> /ConfigCheck/ConfigureFile

}

Check_DeviceCheck() {

    lspci -vv | tr -d + | tr -d - | sed "/Address/d" | sed "/Interrupt/d" >> /ConfigCheck/ConfigureFile 

}

Check_HddCheck() {

    a=`fdisk -l | grep "Disk /dev/sd[a-z]" | wc -l`
    b=`fdisk -l | grep "Disk /dev/hd[a-z]" | wc -l`
    c=`fdisk -l | grep "Disk /dev/nvme[0-9][a-z]" | wc -l`
    sum=`expr $a + $b + $c`
	
    echo -e "Total HDD q'ty: $sum" >> /ConfigCheck/ConfigureFile

}

Check_HddCheck2() {

    hdd=($(smartctl --scan | grep "/dev/sd" | awk -F'-d' '{print$1}'))

    for((i=0; i<${#hdd[@]};i++))
    do
	echo -e "==============================HDD$i==============================" >> /ConfigCheck/ConfigureFile
    smartctl -i ${hdd[$i]} | grep -E -i "Device Model:|Serial Number:|Firmware Version:|SATA Version is:" >> /ConfigCheck/ConfigureFile
    done

}

Check_MemoryTotalSize() {

    cat /proc/meminfo | grep "MemTotal" | awk '{print $2 }' > /ConfigCheck/MemoryConfig

}

Check_LanLinkCheck() {
	
	server_ip0=`cat /ConfigCheck/Config/Config_Server.txt`
    awk '{print $1" "$2}' < /ConfigCheck/Config/IP_Address.txt | while read ip interface;
    do
        if ping -c4 $server_ip0 -I $ip -w 30 ; then
	        result=$?
        else
	        result=$?
        fi

        if [ $result == 0 ]; then
	        echo "$ip is link"
        else
	        echo "$ip is not link"
	        echo "##################  Count "$count"  Lan Link Check fail !! " >> /ConfigCheck/log
	        exit 1
        fi
    done
}

Check_IperfCheck() {

    rm -f /ConfigCheck/golden_iperf

    awk '{print $1" "$2}' < /ConfigCheck/Config/IP_Address.txt | while read ip interface;
    do
	    iperf -c $server_ip0 -B $ip > IperfResult.txt 	
	    tail -n 1 IperfResult.txt | awk -F"Bytes" '{print $2}' | awk -F" " '{print $1}' > golden_iperf
    done
	
}



Check_CheckMemoryTotalSize() {

	GoldMemTotal=`cat /ConfigCheck/GoldenMemoryConfig`
    echo GoldenMemoryConfig=$GoldMemTotal
	MemTotal=`cat /ConfigCheck/MemoryConfig`
    echo MemoryConfig=$MemTotal
	MemSizeP=`expr $MemTotal \- $GoldMemTotal`
    echo MemSizeP=$MemSizeP           

    abs() 
    { 
        echo $a1 | awk '{print sqrt($a1*$a1)}';
        ak=`echo $a1 | awk '{print sqrt($a1*$a1)}'`;
    }  
    a1=$MemSizeP
    abs
    echo $ak
	#NOTE:1048576 means the memory not lost more 1GB
    if [ $ak -le 1048576 ]; then
        echo "Memory Check PASS! @_@"
        echo "Memory reduce vaule: $ak"
        return 0 
    else
        echo "Memory Check FAIL!>_<"
        echo "Memory reduce vaule: $ak"
        echo "Memory reduce vaule: $ak" >> /ConfigCheck/log
        return 1
    fi
	
}

Check_IperfCheck2() {

    rm -f /ConfigCheck/current_iperf

    awk '{print $1" "$2}' < /ConfigCheck/Config/IP_Address.txt | while read ip interface;
    do
	    iperf -c $server_ip0 -B $ip > IperfResult.txt 	
	    tail -n 1 IperfResult.txt | awk -F"Bytes" '{print $2}' | awk -F" " '{print $1}' > current_iperf 
    done

    s=`cat golden_iperf | wc -l`  

    for ((i=1; i<=${s} ; i++))
    do
	    gp=`cat golden_iperf | sed -n ${i}p`
	    cp=`cat current_iperf | sed -n ${i}p`
	    ratio=`awk 'BEGIN{printf"%.2f\n",('$cp'/'$gp')}'`
	    #echo $ratio
	    if (echo ${ratio} 0.8 | awk '!($1<$2){exit 1}'); then
		    return 1	
	    fi
    done

}
 
Check_feedback() {

	host=`cat /ConfigCheck/Config/Config_Server.txt`
	file=`cat /ConfigCheck/Config/Uploadfile.txt`
    id="admin"
    pw="admin"
    remodir="/"

    rm -rf /ConfigCheck/$file
    cp -pf /ConfigCheck/Config/Count /ConfigCheck/$file

    cd /ConfigCheck
    echo "open $host
    user $id $pw
    binary
    prompt
    cd $remodir
    put $file
    dir
    bye
    " | ftp -n
}
function result_check() {

if [ $2 -eq 0 ]; then

echo -e "\033[032m$1 result is pass\033[0m!!"
echo "$1 pass" >> /ConfigCheck/result_check.txt

else

echo -e "\033[031m$1 result is fail\033[0m!!"
echo "$1 fail" >> /ConfigCheck/result_check.txt

fi
}

echo "The Configcheck Test will start after 15 sec"
sleep 15
echo "The Configcheck Test is in progress ......."
sleep 60
#Check_BMCVersion
#Check_DeviceCheck
#/ConfigCheck/Config/DeviceCheck.sh
Check_HddCheck
#Check_HddCheck2

diff /ConfigCheck/ConfigureFile /ConfigCheck/GoldenConfigureFile 2>&1>/dev/null

result0=$?
result_check "Configcheck" $result0
#Check_MemoryTotalSize
#Check_CheckMemoryTotalSize

##Check AER
dmesg | grep -i "RxErr"
result4=$?

result_check "Memorycheck" $result4
if [ "$AC" -eq 1 ]; then
    Check_LanLinkCheck
    result3=$?
    result_check "LanLinkcheck" $result3
    Check_IperfCheck2
    result5=$?
    result_check "Iperfcheck" $result5
fi

if [ "$AC" -eq 1 ]; then	
    all=$[ result0 + result3 + result4 + result5]
else
    all=$[ result0 + result4]
fi	

if [ "$AC" -eq 1 ]; then
    pstatus="AC"
elif [ "$DC" -eq 1 ]; then
	pstatus="DC"
else 
	pstatus="Reboot"
fi

if [ $all -eq 1 ]; then

        echo "================================================"
        echo "$pstatus Cycle times :" `cat $FILE`
        echo "Ctrl+C to break"
        echo "================================================"

	echo -en "                                      \n"
	echo -en "######     ####     ######   ######	\n"
	echo -en "##   ##  ##    ##  ##       ##	\n"
	echo -en "######   ########   ######   ######	\n"
	echo -en "##       ##    ##        ##       ##	\n"		
	echo -en "##       ##    ##   ######   ######	\n"
	echo -en "                                      \n"
	sleep 5

        if [ "$AC" -eq 1 ]; then
            Check_feedback
            sleep 5
            init 0
        elif [ "$DC" -eq 1 ]; then
            #ipmitool power cycle
			echo 0 > /sys/class/rtc/rtc0/wakealarm
			echo `date '+%s' -d '+ 30 seconds'` > /sys/class/rtc/rtc0/wakealarm
			#cat /proc/driver/rtc
			shutdown -h now   
        else 
			sleep 5	
            /sbin/reboot
        fi
 
else
  
	diff /ConfigCheck/ConfigureFile /ConfigCheck/GoldenConfigureFile 2>&1>/dev/null > /ConfigCheck/faillog/"$count"_log


	echo "##################  Count:"$count"  ################## " >> /ConfigCheck/log
	echo "     " >> /ConfigCheck/log
	diff /ConfigCheck/ConfigureFile /ConfigCheck/GoldenConfigureFile >> /ConfigCheck/log
	echo "     " >> /ConfigCheck/log


	cp /ConfigCheck/ConfigureFile /ConfigCheck/faillog/source_log/"$count"_ConfigureFile
        echo "================================================"
        echo "$pstatus Cycle times :" `cat $FILE`
        echo "Ctrl+C to break"
        echo "================================================"
  
        echo "-------------------------------------------"
        echo -en "                                      \n"
        echo -en "#######   ####    #####  ##           \n"
        echo -en "##      ##    ##   ##    ##           \n"
        echo -en "######  ########   ##    ##           \n"
        echo -en "##      ##    ##   ##    ##           \n"
        echo -en "##      ##    ##  #####  #######      \n"
        echo -en "                                      \n"
		
		#Control UUT will hang while the check is failed
		if [ "$HOLD" -eq 1 ]; then
		
			echo -en "Stop $pstatus on/off..............."
			read
			
		else
		
			if [ "$AC" -eq 1 ]; then
            	sleep 5
            	init 0
			elif [ "$DC" -eq 1 ]; then
				sleep 5
				echo 0 > /sys/class/rtc/rtc0/wakealarm
				echo `date '+%s' -d '+ 30 seconds'` > /sys/class/rtc/rtc0/wakealarm
				#cat /proc/driver/rtc
				shutdown -h now  
			else    
				sleep 5
				/sbin/reboot
			fi
				
        fi
fi
